image: jdrouet/docker-with-buildx:stable

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  IMAGE_NAME: "$CI_REGISTRY_IMAGE"
  IMAGE_TAG: "$CI_COMMIT_BRANCH"
  IMAGE_FULL: "$CI_REGISTRY_IMAGE:$CI_COMMIT_BRANCH"


stages:
  - build
  - deploy

build_container:
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" registry.gitlab.com
  script:
    - docker buildx create --use
    - docker buildx build --push --platform linux/arm64/v8,linux/amd64 --tag "$IMAGE_FULL" .


deploy_staging:
  stage: deploy
  image: willhallonline/ansible:2.16.4-alpine-3.18
  before_script:
    - cp $SSHKEY /tmp/sshkey
    - chmod 600 /tmp/sshkey
  script:
    - ansible-playbook -i "$ANSIBLE_INV" deploy/container.yml --limit staging
  environment:
    name: staging
    url: https://staging-dl.orangefox.download/


deploy_fallback:
  stage: deploy
  image: willhallonline/ansible:2.16.4-alpine-3.18
  before_script:
    - cp $SSHKEY /tmp/sshkey
    - chmod 600 /tmp/sshkey
  script:
    - ansible-playbook -i "$ANSIBLE_INV" deploy/container.yml --limit fallback
  environment:
    name: fallback
    url: https://fallback-dl.orangefox.download/
  when: manual
  only:
    - master
    - staging
    - prod
    - test-ci


deploy_prod:
  stage: deploy
  image: willhallonline/ansible:2.16.4-alpine-3.18
  before_script:
    - cp $SSHKEY /tmp/sshkey
    - chmod 600 /tmp/sshkey
  script:
    - ansible-playbook -i "$ANSIBLE_INV" deploy/container.yml --limit prod
  environment:
    name: prod
    url: https://prod-dl.orangefox.download/
  when: manual
  only:
    - master
    - staging
    - prod
    - test-ci
